<?php

/**
 * Output the contents of the footer
 * Execute any shortcodes that might be present
 *
 * @since 1.0.1
 */
add_filter('genesis_footer_output', 'do_shortcode', 20);
add_action('genesis_footer', 'genesis_do_footer');
function genesis_do_footer() {
	
	// Build the filterable text strings. Includes shortcodes.
	$backtotop_text = apply_filters('genesis_footer_backtotop_text', '[footer_backtotop]');
	$creds_text = apply_filters('genesis_footer_creds_text', 'Copyright [footer_copyright] [footer_childtheme_link] &middot; [footer_genesis_link] &middot; [footer_wordpress_link] &middot; [footer_loginout]');
	
	// For backward compatibility (pre-1.1 filter)
	if( apply_filters('genesis_footer_credits', FALSE) ) {
		$filtered = apply_filters('genesis_footer_credits', '[footer_childtheme_link] &middot; [footer_genesis_link] &middot; [footer_wordpress_link]');
		$creds_text = 'Copyright [footer_copyright] '. $filtered .' &middot; [footer_loginout]';
	}
	
	$output = '<div class="gototop">' . $backtotop_text . '</div>' . '<div class="creds">' . $creds_text . '</div>';
	
	echo apply_filters('genesis_footer_output', $output, $backtotop_text, $creds_text);
	
}

/**
 * Output the footer scripts, defined in Theme Settings
 */
add_filter('genesis_footer_scripts', 'do_shortcode');
add_action('wp_footer', 'genesis_footer_scripts');
function genesis_footer_scripts() {
	
	echo apply_filters('genesis_footer_scripts', genesis_option('footer_scripts'));

}